VERSION 5.00
Begin VB.Form Form1 
   AutoRedraw      =   -1  'True
   Caption         =   "Split File into Lines"
   ClientHeight    =   4020
   ClientLeft      =   120
   ClientTop       =   420
   ClientWidth     =   7410
   BeginProperty Font 
      Name            =   "Segoe UI"
      Size            =   9.75
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   ScaleHeight     =   4020
   ScaleWidth      =   7410
   StartUpPosition =   2  'CenterScreen
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Declare Function SysAllocStringByteLen Lib "oleaut32" (B As Byte, ByVal Length As Long) As String
Private Declare Function SafeArrayRedim Lib "oleaut32" (ByVal saPtr As Long, saBound As Long) As Long

Const FILE_TO_SPLIT As String = "c:\temp\bible13.txt", LINE_DELIM As String = vbCrLf
 
Implements ICSVCallback
Private CSV As cCSV, Lines() As String, UBL As Long

Private UseSysAllocStringByteLenAPI As Boolean
Private Lines2() As String

Private Sub Form_Click()
  Cls
    
    Me.ForeColor = vbBlack
    
    Print "File to split: "; FILE_TO_SPLIT; vbLf
            
    Test_Slurp_Split
    Test_LineInput
    Test_Lickety_SplitFile
 
    Print "-------------------------------------------------------------------------------------"
    Test_RC6CSV_UseAPI
    Test_RC6CSV_NotUseAPI
    Print "-------------------------------------------------------------------------------------"
    
    Test_Merri_QuickSplit
    Test_Merri_QuickSplit_New
    
    Print "-------------------------------------------------------------------------------------"
    Test_Xiaoyao
    Test_Xiaoyao_New
    
End Sub

Private Sub Test_Slurp_Split()
    Dim F As Integer, i As Long, S As String, sError As String
     
    On Error GoTo Err_Handler
        
    Me.ForeColor = vbBlack
    New_c.Timing True
    
    F = FreeFile(0)
    Open FILE_TO_SPLIT For Binary Access Read As #F
      S = Space$(LOF(F)): Get F, , S
    Close #F
    Lines = Split(S, LINE_DELIM)
            
    If Len(S) Then
        Print "Slurp+Split read"; UBound(Lines) + 1; " lines, took "; New_c.Timing
        Erase Lines: UBL = 0: i = 0: S = vbNullString
    Else
        sError = "Error"
        GoTo Err_Handler
    End If
                
    DoEvents
    
    Exit Sub
    
Err_Handler:
    Me.ForeColor = vbRed
    If sError = vbNullString Then sError = Error
    Print "Slurp+Split read - "; sError
    Erase Lines: UBL = 0: i = 0: S = vbNullString
End Sub

Private Sub Test_LineInput()
    Dim F As Integer, i As Long, S As String, sError As String
     
    On Error GoTo Err_Handler
            
    If LINE_DELIM = vbLf Then
        sError = "Error"
        GoTo Err_Handler
    End If
    
    Me.ForeColor = vbBlack
    New_c.Timing True
    
    F = FreeFile(0)
    Open FILE_TO_SPLIT For Input As #F Len = 32767
    Do Until EOF(F)
        If i >= UBL Then UBL = UBL * 1.6 + 8192: ReDim Preserve Lines(UBL)
        Line Input #F, Lines(i)
        i = i + 1
    Loop
    Close #F
    
    If i > 1 Then
        If i - 1 > UBound(Lines) Then ReDim Preserve Lines(i - 1)
        Print "Line Input# read"; i; " lines, took "; New_c.Timing
        Erase Lines: UBL = 0: i = 0: S = vbNullString
    Else
      sError = "Error"
      GoTo Err_Handler
    End If
    
    DoEvents
    
    Exit Sub
    
Err_Handler:
    Me.ForeColor = vbRed
    If sError = vbNullString Then sError = Error
    Print "Line Input# read - "; sError
    Erase Lines: UBL = 0: i = 0: S = vbNullString
End Sub

Private Sub Test_Lickety_SplitFile()
    Dim F As Integer, i As Long, S As String, sError As String
     
    On Error GoTo Err_Handler
    
    Me.ForeColor = vbBlack
    New_c.Timing True
    
    With New Lickety
        Lines = .SplitFile(FILE_TO_SPLIT, LineDelim:=LINE_DELIM)
    End With
      
    If UBound(Lines) >= 0 Then
        Print "Lickety.SplitFile read"; UBound(Lines) + 1; " lines, took "; New_c.Timing
        Erase Lines: UBL = 0: i = 0: S = vbNullString
    Else
        sError = "Error"
        GoTo Err_Handler
    End If
    
    DoEvents
    
    Exit Sub
    
Err_Handler:
    Me.ForeColor = vbRed
    If sError = vbNullString Then sError = Error
    Print "Lickety.SplitFile read - "; sError
    Erase Lines: UBL = 0: i = 0: S = vbNullString
End Sub

Private Sub Test_RC6CSV_UseAPI()
    Dim F As Integer, i As Long, S As String, sError As String
     
    On Error GoTo Err_Handler
    
    Me.ForeColor = vbBlack
    UseSysAllocStringByteLenAPI = True
    New_c.Timing True
    
    Set CSV = New_c.CSV(vbNullChar, vbNullChar) 'prepare for "raw-line-mode"
    CSV.ParseFile FILE_TO_SPLIT, Me
                   
    If CSV.RowsParsed >= 0 Then
        ReDim Preserve Lines(CSV.RowsParsed - 1)
        Print "RC6.cCSV (Use API) read"; UBound(Lines) + 1; " lines, took "; New_c.Timing
        Erase Lines: UBL = 0: i = 0: S = vbNullString
    Else
        sError = "Error"
        GoTo Err_Handler
    End If
            
    DoEvents
    
    Exit Sub
    
Err_Handler:
    Me.ForeColor = vbRed
    If sError = vbNullString Then sError = Error
    Print "RC6.cCSV (Use API) read - "; sError
    Erase Lines: UBL = 0: i = 0: S = vbNullString
End Sub

Private Sub Test_RC6CSV_NotUseAPI()
    Dim F As Integer, i As Long, S As String, sError As String
     
    On Error GoTo Err_Handler
    
    Me.ForeColor = vbBlack
    UseSysAllocStringByteLenAPI = False
    New_c.Timing True
    
    Set CSV = New_c.CSV(vbNullChar, vbNullChar) 'prepare for "raw-line-mode"
    CSV.ParseFile FILE_TO_SPLIT, Me
    
    If CSV.RowsParsed >= 0 Then
        ReDim Preserve Lines(CSV.RowsParsed - 1)
        Print "RC6.cCSV (Not Use API) read"; UBound(Lines) + 1; " lines, took "; New_c.Timing
        Erase Lines: UBL = 0: i = 0: S = vbNullString
    Else
        sError = "Error"
        GoTo Err_Handler
    End If
    
    DoEvents
    
    Exit Sub
    
Err_Handler:
    Me.ForeColor = vbRed
    If sError = vbNullString Then sError = Error
    Print "RC6.cCSV (Not Use API) read - "; sError
    Erase Lines: UBL = 0: i = 0: S = vbNullString
End Sub

Private Sub Test_Merri_QuickSplit()
    Dim F As Integer, i As Long, S As String, sError As String
     
    On Error GoTo Err_Handler
    
    Me.ForeColor = vbBlack
    
    New_c.Timing True
      With New cQuickSplit
        sError = .QuickSplit_File(FILE_TO_SPLIT, LINE_DELIM, Lines)
      End With
      If Len(sError) Then GoTo Err_Handler
    Print "Merri-QuickSplit read"; UBound(Lines) + 1; " lines, took "; New_c.Timing
    Erase Lines: UBL = 0: i = 0: S = vbNullString
    
    DoEvents
    
    Exit Sub
    
Err_Handler:
    Me.ForeColor = vbRed
    If sError = vbNullString Then sError = Error
    Print "Merri-QuickSplit read - "; sError
    Erase Lines: UBL = 0: i = 0: S = vbNullString
End Sub

Private Sub Test_Merri_QuickSplit_New()
    Dim F As Long, B() As Byte, i As Long, S As String, sError As String
     
    On Error GoTo Err_Handler
    
    Me.ForeColor = vbBlue
    
    New_c.Timing True
          
    F = FreeFile(0)
    Open FILE_TO_SPLIT For Binary Access Read As #F
      ReDim B(LOF(F) - 1): Get F, , B
    Close #F
        
    Lines = Strings2.Split(StrConv(B, vbUnicode), LINE_DELIM, , [Split BinaryCompare])
    
    Print "Merri-QuickSplit-New read"; UBound(Lines) + 1; " lines, took "; New_c.Timing
    Erase Lines: UBL = 0: i = 0: S = vbNullString
    
    DoEvents
    Me.ForeColor = vbBlack
    
    Exit Sub
    
Err_Handler:
    Me.ForeColor = vbRed
    If sError = vbNullString Then sError = Error
    Print "Merri-QuickSplit-New read - "; sError
    Erase Lines: UBL = 0: i = 0: S = vbNullString
End Sub

Private Sub Test_Xiaoyao(Optional FileLenA As Long)
    'QueryPerformanceCounter CPUv1
    
    Dim Str As String, sError
    Dim F As Long, Block() As Byte, i As Long, S As String

    On Error GoTo Err_Handler
        
    Me.ForeColor = vbBlack
    New_c.Timing True
    
    F = FreeFile(0)
    Open FILE_TO_SPLIT For Binary Access Read As #F
    FileLenA = LOF(F)
    ReDim Block(FileLenA - 1)
    Get #F, , Block
    Close #F
    
    'QueryPerformanceCounter CPUv2
    
    Str = StrConv(Block, vbUnicode)
    
    'QueryPerformanceCounter CPUv3
    
    Dim lngA As Long, lngCount As Long, lngDelLen As Long, lngExpLen As Long, lngResults() As Long
    ' some dummy variables that we happen to need
    Dim Compare As VbCompareMethod, SafeArrayBound(1) As Long
    
        ' length information
        lngExpLen = LenB(Str)
        lngDelLen = LenB(LINE_DELIM)
         ' validate lengths and limit (limit must be larger than 0 or it must be unlimited)
        If lngExpLen > 0 And lngDelLen > 0 Then
            ' now look up for the first position
            lngA = InStrB(1, Str, LINE_DELIM, Compare)
            ' InStrB is very fast, but it may give "between characters" results
            Do Until (lngA And 1) Or (lngA = 0)
                ' this is why we look for odd positions (1, 3, 5, 7 etc. are a valid position)
                lngA = InStrB(lngA + 1, Str, LINE_DELIM, Compare)
            Loop
    '------------------
                ' unlimited, reserve space for maximum possible amount of returned items
                ReDim lngResults(0 To (lngExpLen \ lngDelLen))
                ' index positions until none is found
                Do While lngA > 0
                    ' remember this position
                    lngResults(lngCount) = lngA
                    ' look for the next one
                    lngA = InStrB(lngA + lngDelLen, Str, LINE_DELIM, Compare)
                    Do Until (lngA And 1) Or (lngA = 0)
                        lngA = InStrB(lngA + 1, Str, LINE_DELIM, Compare)
                    Loop
                    ' increase found counter
                    lngCount = lngCount + 1
                Loop
    '-----------------
            ' set results to actual findings
            ReDim Preserve Lines(0 To lngCount)
            ' see if we found any results
            If lngCount = 0 Then
                ' nope, just set the only item to be the whole string
                Lines(0) = Str
            Else
                ' get the first item
                Lines(0) = LeftB$(Str, lngResults(0) - 1)
                ' get the other items except the last one
                For lngCount = 0 To lngCount - 2
                    Lines(lngCount + 1) = MidB$(Str, lngResults(lngCount) + lngDelLen, lngResults(lngCount + 1) - lngResults(lngCount) - lngDelLen)
                Next lngCount
                ' get the last item
                Lines(lngCount + 1) = RightB$(Str, lngExpLen - lngResults(lngCount) - lngDelLen + 1)
            End If
        Else
            ' clean any possible data that exists in the passed string array (like if it is multidimensional)
            If Not Not Lines Then Erase Lines
            ' mysterious IDE error fix
            Debug.Assert App.hInstance
            ' reset to one element, one dimension
            ReDim Lines(0 To 0)
            ' custom redimension: remove the items (this duplicates the VB6 Split behavior)
            SafeArrayRedim Not Not Lines, SafeArrayBound(0)
        End If
        
        
    'QueryPerformanceCounter CPUv4
    
    Print "xiaoyao read"; UBound(Lines) + 1; " lines, took "; New_c.Timing
    Erase Lines: UBL = 0: i = 0: S = vbNullString
    
    DoEvents
    Exit Sub
    
Err_Handler:
    Me.ForeColor = vbRed
    If sError = vbNullString Then sError = Error
    Print "xiaoyao read - "; sError
    Erase Lines: UBL = 0: i = 0: S = vbNullString
End Sub

Private Sub Test_Xiaoyao_New(Optional FileLenA As Long)
    'QueryPerformanceCounter CPUv1
    
    Dim Str As String, sError
    Dim F As Long, Block() As Byte, i As Long, S As String

    On Error GoTo Err_Handler
    
    Dim U1 As Currency, U2 As Currency
    Me.ForeColor = vbBlue
    New_c.Timing True
    
    F = FreeFile(0)
    Open FILE_TO_SPLIT For Binary Access Read As #F
    FileLenA = LOF(F)
    ReDim Block(FileLenA - 1)
    Get #F, , Block
    Close #F
    
    'QueryPerformanceCounter CPUv2
    
    Str = StrConv(Block, vbUnicode)
    'New_c.Timing True
    StringToArray_ByPointer Str, LenB(Str), Lines
    
    
    Print "xiaoyao-new read"; UBound(Lines) + 1; " lines, took ?"; "PointerSplit:" & New_c.Timing
 
'    Dim ErrLines As Long 'Check if the data is the same
'    For i = 0 To UBound(Lines)
'        If Lines(i) <> Lines2(i) Then
'            ErrLines = ErrLines + 1
'        End If
'    Next
'    If ErrLines <> 0 Then MsgBox "ErrLines=" & ErrLines
    
    CLEAR2
    Erase Lines: UBL = 0: i = 0: S = vbNullString
    
    Erase Lines2
    DoEvents
    Exit Sub
    
Err_Handler:

    Me.ForeColor = vbRed
    If sError = vbNullString Then sError = Error
    Print "xiaoyao-new read - "; sError
    Erase Lines: UBL = 0: i = 0: S = vbNullString
End Sub

Private Function ICSVCallback_NewValue(ByVal RowNr As Long, ByVal ColNr As Long, B() As Byte, ByVal BValStartPos As Long, ByVal BValLen As Long) As Long
    If BValLen = 0 Then Exit Function
    If RowNr >= UBL Then UBL = RowNr + RowNr + 9999: ReDim Preserve Lines(0 To UBL)
    
    If UseSysAllocStringByteLenAPI = True Then
        Lines(RowNr) = SysAllocStringByteLen(B(BValStartPos), BValLen)
    Else
        Lines(RowNr) = CSV.GetStringValue(B, BValStartPos, BValLen)
    End If
  
End Function
 
