VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cQuickSplit"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
 
Public Function QuickSplit_File(FileName As String, Delimiter As String, ResultSplit() As String) As String
  Dim F As Long, B() As Byte
  
  On Error GoTo Err_Handler
  
  F = FreeFile(0)
  Open FileName For Binary Access Read As #F
    ReDim B(LOF(F) - 1): Get F, , B
  Close #F

  QuickSplit_Best StrConv(B, vbUnicode), Delimiter, ResultSplit
  Exit Function
  
Err_Handler:
    QuickSplit_File = Error
End Function
 
Public Sub QuickSplit_Best(S As String, Delimiter As String, ResultSplit() As String)
' Short, commented & fully VB5 compatible version of QuickSplit_Best at http://www.vbforums.com/showthread.php?t=540323
    ' general variables that we need
    Dim lngA As Long, lngCount As Long, lngDelLen As Long, lngExpLen As Long, lngResults() As Long
    ' some dummy variables that we happen to need
 
    ' length information
    lngExpLen = LenB(S)
    lngDelLen = LenB(Delimiter)
     ' validate lengths and limit (limit must be larger than 0 or it must be unlimited)
    If lngExpLen > 0 And lngDelLen > 0 Then
        ' now look up for the first position
        lngA = InStrB(1, S, Delimiter)
        ' InStrB is very fast, but it may give "between characters" results
        Do Until (lngA And 1) Or (lngA = 0)
            ' this is why we look for odd positions (1, 3, 5, 7 etc. are a valid position)
            lngA = InStrB(lngA + 1, S, Delimiter)
        Loop
'------------------
            ' unlimited, reserve space for maximum possible amount of returned items
            ReDim lngResults(0 To (lngExpLen \ lngDelLen))
            ' index positions until none is found
            Do While lngA > 0
                ' remember this position
                lngResults(lngCount) = lngA
                ' look for the next one
                lngA = InStrB(lngA + lngDelLen, S, Delimiter)
                Do Until (lngA And 1) Or (lngA = 0)
                    lngA = InStrB(lngA + 1, S, Delimiter)
                Loop
                ' increase found counter
                lngCount = lngCount + 1
            Loop
'-----------------
        ' set results to actual findings
        ReDim Preserve ResultSplit(0 To lngCount)
        ' see if we found any results
        If lngCount = 0 Then
            ' nope, just set the only item to be the whole string
            ResultSplit(0) = S
        Else
            ' get the first item
            ResultSplit(0) = LeftB$(S, lngResults(0) - 1)
            ' get the other items except the last one
            For lngCount = 0 To lngCount - 2
                ResultSplit(lngCount + 1) = MidB$(S, lngResults(lngCount) + lngDelLen, lngResults(lngCount + 1) - lngResults(lngCount) - lngDelLen)
            Next lngCount
            ' get the last item
            ResultSplit(lngCount + 1) = RightB$(S, lngExpLen - lngResults(lngCount) - lngDelLen + 1)
        End If
    Else
        ' clean any possible data that exists in the passed string array
        ResultSplit = Split(vbNullString)
    End If
End Sub
